#!/usr/bin/env python

# Copyright (C) 2002 Jrg Lehmann <joerg@luga.de>
#
# This file is part of PyTone (http://www.luga.de/pytone/)
#
# PyTone is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2
# as published by the Free Software Foundation.
#
# PyTone is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with PyX; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import events

"""Note: A player can request a song from the playlist via the
   event requestnextsong(self)
"""

class player:
    def __init__(self):
        events.ec.subscribe(events.timer, self.timer)
        events.ec.subscribe(events.playerstart, self.playerstart)
        events.ec.subscribe(events.playerstop, self.playerstop)
        events.ec.subscribe(events.playerforward, self.playerforward)
        events.ec.subscribe(events.nextsong, self.nextsong)

    def timer(self):
        """player update, regularly called by PyTone"""
        pass

    def nextsong(self, event):
        """play event.song next"""
        if event.player is self:
            pass

    def playerstart(self, event):
        """start playing"""
        if event.player is self:
            pass

    def playerstop(self, event):
        """stop playing"""
        if event.player is self:
            pass

    def playerforward(self, event):
        """immediately play next song"""
        if event.player is self:
            events.ec.notify(events.requestnextsong(self))

    def playerquit(self):
        """quit player"""
        pass
